Package org.apache.commons.imaging.formats.tiff

## Class TiffField

- java.lang.Object
- - org.apache.commons.imaging.formats.tiff.TiffField

-     public class TiffField
      extends Object

  A TIFF field in a TIFF directory. Immutable.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `TiffField.OversizeValueElement` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TiffField​(int tag, int directoryType, FieldType fieldType, long count, long offset, byte[] value, ByteOrder byteOrder, int sortHint)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `dump()` |
    `void` | `dump​(PrintWriter pw)` |
    `void` | `dump​(PrintWriter pw, String prefix)` |
    `byte[]` | `getByteArrayValue()` | Returns a copy of the raw value of the field.
    `ByteOrder` | `getByteOrder()` | Returns the field's byte order.
    `int` | `getBytesLength()` | The length of the field's value.
    `long` | `getCount()` | Returns the field's count, derived from bytes 4-7.
    `String` | `getDescriptionWithoutValue()` |
    `int` | `getDirectoryType()` |
    `double[]` | `getDoubleArrayValue()` |
    `double` | `getDoubleValue()` |
    `FieldType` | `getFieldType()` | Returns the field's type, derived from bytes 2-3.
    `String` | `getFieldTypeName()` |
    `int[]` | `getIntArrayValue()` |
    `int` | `getIntValue()` |
    `int` | `getIntValueOrArraySum()` |
    `int` | `getOffset()` | Returns the TIFF field's offset/value field, derived from bytes 8-11.
    `TiffElement` | `getOversizeValueElement()` |
    `int` | `getSortHint()` |
    `String` | `getStringValue()` |
    `int` | `getTag()` | Returns the field's tag, derived from bytes 0-1.
    `TagInfo` | `getTagInfo()` |
    `String` | `getTagName()` |
    `Object` | `getValue()` |
    `String` | `getValueDescription()` |
    `boolean` | `isLocalValue()` | Indicates whether the field's value is inlined into the offset field.
    `String` | `toString()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### TiffField

          public TiffField​(int tag,
                           int directoryType,
                           FieldType fieldType,
                           long count,
                           long offset,
                           byte[] value,
                           ByteOrder byteOrder,
                           int sortHint)

  - ### Method Detail

    - #### getDirectoryType

          public int getDirectoryType()

    - #### getTagInfo

          public TagInfo getTagInfo()

    - #### getTag

          public int getTag()

      Returns the field's tag, derived from bytes 0-1.
      Returns:
        the tag, as an `int` in which only the lowest 2 bytes are set

    - #### getFieldType

          public FieldType getFieldType()

      Returns the field's type, derived from bytes 2-3.
      Returns:
        the field's type, as a `FieldType` object.

    - #### getCount

          public long getCount()

      Returns the field's count, derived from bytes 4-7.
      Returns:
        the count

    - #### getOffset

          public int getOffset()

      Returns the TIFF field's offset/value field, derived from bytes 8-11.
      Returns:
        the field's offset in a `long` of 4 packed bytes, or its inlined value <= 4 bytes long encoded in the field's byte order.

    - #### getByteOrder

          public ByteOrder getByteOrder()

      Returns the field's byte order.
      Returns:
        the byte order

    - #### getSortHint

          public int getSortHint()

    - #### isLocalValue

          public boolean isLocalValue()

      Indicates whether the field's value is inlined into the offset field.
      Returns:
        true if the value is inlined

    - #### getBytesLength

          public int getBytesLength()

      The length of the field's value.
      Returns:
        the length, in bytes.

    - #### getByteArrayValue

          public byte[] getByteArrayValue()

      Returns a copy of the raw value of the field.
      Returns:
        the value of the field, in the byte order of the field.

    - #### getOversizeValueElement

          public TiffElement getOversizeValueElement()

    - #### getValueDescription

          public String getValueDescription()

    - #### dump

          public void dump()

    - #### dump

          public void dump​(PrintWriter pw)

    - #### dump

          public void dump​(PrintWriter pw,
                           String prefix)

    - #### getDescriptionWithoutValue

          public String getDescriptionWithoutValue()

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getTagName

          public String getTagName()

    - #### getFieldTypeName

          public String getFieldTypeName()

    - #### getValue

          public Object getValue()
                          throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getStringValue

          public String getStringValue()
                                throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getIntArrayValue

          public int[] getIntArrayValue()
                                 throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getDoubleArrayValue

          public double[] getDoubleArrayValue()
                                       throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getIntValueOrArraySum

          public int getIntValueOrArraySum()
                                    throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getIntValue

          public int getIntValue()
                          throws ImageReadException

      Throws:
        `ImageReadException`

    - #### getDoubleValue

          public double getDoubleValue()
                                throws ImageReadException

      Throws:
        `ImageReadException`